#import "myImage.h"

@implementation myImage


- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		
	}
	return self;
}

-(void)awakeFromNib{
	theImage = [[NSImage alloc]initWithContentsOfFile:@"bigone.jpg"];
	point_to_draw = NSMakePoint(0,0);
}

- (void)drawRect:(NSRect)rect
{
	NSLog(@"drawn");
	[self setFrameSize:[theImage size]];
	
	[theImage drawInRect:[self bounds] fromRect:[self bounds] operation:NSCompositeSourceOver fraction:1.0];
	
	NSString *str = [NSString stringWithString:[text_to_draw stringValue]];
	
	NSFont *font = [NSFont fontWithName:[current_font stringValue] size:[current_size floatValue]];
	NSMutableDictionary *attributes = [NSMutableDictionary dictionary];
	[attributes setObject:font forKey:NSFontAttributeName];
	[attributes setObject:[current_color color] forKey:NSForegroundColorAttributeName];
	[str drawAtPoint:point_to_draw withAttributes:attributes];
	
}

- (void)mouseDown:(NSEvent *)theEvent
{
	NSPoint eventLocation = [theEvent locationInWindow];
	point_to_draw = [self convertPoint:eventLocation fromView:nil];
	[self setNeedsDisplay:TRUE];
}

- (void)mouseDragged:(NSEvent *)theEvent{
	NSPoint eventLocation = [theEvent locationInWindow];
	point_to_draw = [self convertPoint:eventLocation fromView:nil];
	[self setNeedsDisplay:TRUE];
}


-(IBAction)drawTextToImage:(id)sender;
{
	[self setNeedsDisplay:YES];
}

-(IBAction)exportImage:(id)sender
{
	NSSavePanel *savePanel = [NSSavePanel savePanel];
	SEL sel = @selector(savePanelDidEnd:returnCode:contextInfo:);
	[savePanel beginSheetForDirectory:@"~/Documents"
								 file:@"archive.pdf"
					   modalForWindow:[self window]
						modalDelegate:self
					   didEndSelector:sel 
						  contextInfo:nil];
}

-(void)savePanelDidEnd:(NSSavePanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void*)context
{
	if(returnCode == NSOKButton){
		NSData *viewData = [self dataWithPDFInsideRect:[self bounds]];
		[viewData writeToFile:[sheet filename] atomically:YES];
	}
}


-(IBAction)loadImageFromPath:(id)sender
{
	[theImage release];
	theImage = [[NSImage alloc]initWithContentsOfFile:[current_image stringValue]];
	
	
	[self setNeedsDisplay:YES];
}

- (BOOL)mouseDownCanMoveWindow
{
	return NO;
}

- (void) dealloc {
	[theImage release];
	[super dealloc];
}
@end
